﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DataError
{
    public class Employee : IDataErrorInfo
    {
        private int _id;
        private string _fullName;
        private double _salary;
        private List<Attendence> _attendDays;


        ///===============
        public BindingList<Employee> EmployeeList()
        {
            BindingList<Employee> elist = new BindingList<Employee>();

            elist.Add(new Employee { ID = 1, FullName = "JOHN", Salary = 5000, AttendDays= ListAttendence().Where (n=>n.ID==1).ToList() });
            elist[0].AttendDays[0].TotalDaysAttend = 33;
            elist.Add(new Employee { ID = 2, FullName = "Mike", Salary = 7000, AttendDays= ListAttendence().Where (n=>n.ID==1).ToList() });
            elist.Add(new Employee { ID = 3, FullName = "shelly", Salary = 1500000, AttendDays = ListAttendence().Where(n => n.ID == 1).ToList() });
            elist.Add(new Employee { ID = 4, FullName = "Ram", Salary = 6000, AttendDays = ListAttendence().Where(n => n.ID == 1).ToList() });
            return elist;
        }

        public List<Attendence> ListAttendence()
        {
            List<Attendence> a = new List<Attendence>();
            a.Add(new Attendence {ID=1, Month = "JAN", TotalDaysAttend = 31 });
            a.Add(new Attendence { ID = 1, Month = "FEB", TotalDaysAttend = 28 });
            a.Add(new Attendence { ID = 1, Month = "APR", TotalDaysAttend = 15 });
            a.Add(new Attendence { ID = 4, Month = "MAR", TotalDaysAttend = 20 });
            a.Add(new Attendence { ID = 4, Month = "MAY", TotalDaysAttend = 23 });
            ////////////////////////////
            a.Add(new Attendence { ID = 2, Month = "JAN", TotalDaysAttend = 20 });
            a.Add(new Attendence { ID = 2, Month = "FEB", TotalDaysAttend = 12 });
            a.Add(new Attendence { ID = 3, Month = "APR", TotalDaysAttend = 15 });
            a.Add(new Attendence { ID = 3, Month = "MAR", TotalDaysAttend = 21 });
            a.Add(new Attendence { ID = 2, Month = "MAY", TotalDaysAttend = 23 });
            return a;
        }
        public int ID
        {
            get { return _id; }
            set { _id = value; }
        }
        public string FullName
        {
            get { return _fullName; }
            set { _fullName = value; }
        }
        public double Salary
        {
            get { return _salary; }
            set { _salary = value; }
        }
        public List<Attendence> AttendDays
        {
            get
            {
                return _attendDays;
            }
            set { _attendDays = value; }
        }
        #region IDataErrorInfo Members

        private string _error = "";
        [Browsable(false)]
        public string Error
        {
            get {
                validateRecord();
                return _error; }
            set { _error = value; }
        }

        public string this[string  columnName]
        {
            get
            {
                if (columnName=="Salary" && Salary>10000)
                     _error = "Salary must be less then 10000!";
                else 
                {
                        
                        foreach (var x in AttendDays)
                        {
                            if (x.TotalDaysAttend>31)
                            {
                              
                                _error = "Month total days not exceed 31";
                                break;
                            }
                            else
                                _error = null;
                        }
                }
               
                
                return _error;
                
            }
        }

        private void validateRecord()
        {
            if (Salary > 10000)
                _error = "Salary must be less then 10000!";
            else
            {
                foreach (var x in AttendDays)
                {
                    if (x.TotalDaysAttend > 31)
                    {

                        _error = "Month total days not exceed 31";
                        break;
                    }
                    else
                        _error = null;
                }
            }
            Attendence att = _attendDays.FirstOrDefault(at => !string.IsNullOrEmpty(at.Error));
            if (att != null)
                _error = att.Error;
        }

        #endregion
    }
}
